/**************************************************
FileListMaker.java
*  Creates the File List for Droid to scan
*
* Written by Jacob Bartel
************************************************/
package bin;

import java.io.*;
import java.util.*;

public class FileListMaker{
	static ArrayList path = new ArrayList();


	public static void main(String[] args){
		System.out.println("");
		System.out.println("Creating File list...");
		System.out.println("");
		try{
			
			if(args.length <1)
			{
				System.out.println("Top-most file or directory must be specified");
			}else{
			
	
				//All the arguments are compiled into one file name
				String topMost = "";
				for(int i=0; i<args.length; i++){
					if(args[i].equals("..")){
						i++;
						
						if(args[i].charAt(1)==':'){ //if the file path was already absolute with files home
							topMost = args[i];
						}else{ //if the file path was relative without files home 
							topMost += args[i];
						}
					}else{
						if(i>0){
							topMost += " ";
						}
						topMost += args[i];
					}
				}
				
				makeFileList(topMost);
				
				
			}
		}catch(IOException e){
			e.printStackTrace(new PrintStream(System.out));
		}
	}

	/***********************************************************
	*	Starts creating the fileList
	***********************************************************/
	public static void makeFileList(String fileName) throws IOException{
		File current = new File(fileName); //The top most file
		path.add(fileName);
		
		File outFile = new File(fileName+"_fileList.xml"); //The output file
		if(outFile.exists()){
			outFile.delete();
		}
		
		//outFile.createNewFile();
		
		
		BufferedWriter out = new BufferedWriter(new FileWriter(fileName+"_fileList.xml"));
		out.write("<FileCollection>");
		out.newLine();
		traverseFileTree(current, out);
		out.write("</FileCollection>");
		out.newLine();
		
		
		out.flush();
		out.close();
	}
	
	
	/*****************************************************************
	*	Traverses the file tree to print file names in the file list
	******************************************************************/
	public static void traverseFileTree(File current,BufferedWriter out) throws IOException{
		if(current.isDirectory()){  //if the file is a directory, traverse it's contents
			String[] contents = current.list();
			for(int i=0; i<contents.length; i++){
				path.add("\\"+contents[i]);
				traverseFileTree(new File(currPath()),out);
				path.remove(path.size()-1);
			}
		}else{  //otherwise, print it in the fileList
			out.write("\t<IdentificationFile Name=\""+currPath()+"\" />");
			out.newLine();
		}
		
	}
	
	/**********************************************************************
	*	Returns the current stored path
	**********************************************************************/
	public static String currPath(){
		String toReturn = "";
		for(int i=0; i<path.size(); i++){
			toReturn += (String) path.get(i);
		}
		return toReturn;
	}

}