package bin.parser;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;

public class PrintResults{
	public static void main(String[] args){
		if(args.length <1){
			System.out.println("Error: Top-most folder or file must be specified");
		}else{	
			String topMost = "";
			for(int i=0; i<args.length; i++){
				
				if(args[i].equals("..")){
					i++;
					if(args[i].charAt(1)==':'){  //if the fileName is already absolute
						topMost = args[i];
					}else{
						if(topMost.charAt(topMost.length()-1)!='\\' && args[i].charAt(0)!='\\'){
							topMost += "\\";
						}
						topMost += args[i];  //if the fileName was not absolute
					}
				}else{
					if(i>0){
					topMost +=" ";
					}
				topMost += args[i];
				}
			}
			
			try{
				System.out.println("");
				System.out.println("Parsing Droid Output...");
				System.out.println("");
				File current = new File(topMost+"_DROIDOut.xml");
				if(!current.exists()){
					topMost+=" ";
				}
				DroidParser.processFile(topMost);
			}catch(Exception e){
				e.printStackTrace(new PrintStream(System.out));
			}
			
			try{
				System.out.println("");
				System.out.println("Parsing Jhove Output...");
				System.out.println("");
				JhoveParser.parseSetOfJhoveOutput(topMost);
			}catch(Exception e){
				e.printStackTrace(new PrintStream(System.out));
			}
			
			try{
				System.out.println("");
				System.out.println("Printing Warnings...");
				System.out.println("");
				PrintWarnings.setUpFilesAndPrint(topMost);
			}catch(Exception e){
				e.printStackTrace(new PrintStream(System.out));
			}
			
			try{
				System.out.println("");
				System.out.println("Printing File Types...");
				System.out.println("");
				PrintFileTypes.setUpFilesAndPrint(topMost);
			}catch(Exception e){
				e.printStackTrace(new PrintStream(System.out));
			}
			
		}
	}
}