/**************************************************
*	runDroid.java
* 	Runs the Droid Scanner on the FileList created in  FileListMaker.java
*
* 	Written by Jacob Bartel
************************************************/
package bin.runPrograms;

import bin.changeName.AdaptFileNames;
import uk.gov.nationalarchives.droid.AnalysisController;
import java.io.File;
import java.io.PrintStream;

public class runDroid{

	public static String temp = "C:\\temp";

	public static void main(String[] args){
		System.out.println("");
		System.out.println("Running Droid...");
		System.out.println("");
		if(args.length <1){
			System.out.println("Error: Top-most folder or file must be specified");
		}else{	
			String topMost = "";
			String droidHome = "";
			for(int i=0; i<args.length; i++){
				
				if(args[i].equals("-d")){
					i++;
					if(i<args.length){
						droidHome = args[i];
					}
				}else if(args[i].equals("..")){
					i++;
					if(args[i].charAt(1)==':'){  //if the fileName is already absolute
						topMost = args[i];
					}else{
						if(topMost.charAt(topMost.length()-1)!='\\' && args[i].charAt(0)!='\\'){
							topMost += "\\";
						}
						topMost += args[i];  //if the fileName was not absolute
					}
				}else{
					if(i>0){
					topMost +=" ";
					}
				topMost += args[i];
				}
			}
			try{
				runDroid.scanWithDroid(topMost+"_fileList.xml", topMost+"_DROIDOut", droidHome);
			}catch(Exception e){
				e.printStackTrace(new PrintStream(System.out));
			}
		}
	}
	
	public static void scanWithDroid(String fileName, String outputFile, String droidHome) throws Exception{
		
		/*String conversion = AdaptFileNames.changeString(fileName);
		String oldFileName = fileName;
		if(!conversion.equals(fileName)){
			File tempFile = new File(temp);
			if(!tempFile.exists()){
				tempFile.mkdirs();
			}
			File file = new File(fileName);
			String shortName = file.getName();
			shortName = AdaptFileNames.changeString(shortName);
			if(!file.renameTo(new File(temp+"\\"+shortName))){
				File dest = new File(temp+"\\"+shortName);
				dest.delete
			}
			fileName = temp+"\\"+shortName;
		}*/
		
		String sigFile = "-S"+droidHome+"\\DROID_SignatureFile_V13.xml";
		String input = "-A"+fileName;
		String output = "-O"+outputFile;
		String[] args = new String[3];
		args[0] = sigFile;
		args[1] = input;
		args[2] = output;
		System.out.println("\n\n");
		System.out.println("\n");
		AnalysisController.main(args);
		
		/*File file = new File(fileName);
		file.renameTo(new File(oldFileName));*/
	}
}