/**************************************************
*	runJhove.java
* 	Runs the Jhove Scanner on a file  system 
*
* 	Written by Jacob Bartel
************************************************/
package bin.runPrograms;

import java.io.PrintStream;

public class runJhove{

	public static void main(String[] args){
		if(args.length <1){
			System.out.println("Error: Top-most folder or file must be specified");
		}else{	
			String topMost = "";
			String module = "";
			String jhoveConfig = "";
			String changesFile = "";
			for(int i=0; i<args.length; i++){
				
				if(args[i].equals("-m")){
					i++;
					if(i<args.length){
						module = args[i];
					}
				}else if(args[i].equals("-j")){
					i++;
					if(i<args.length){
						jhoveConfig = args[i];
					}
				}else if(args[i].equals("..")){
					i++;
					if(args[i].charAt(1)==':'){  //if the fileName is already absolute
						topMost = args[i];
					}else{
						if(topMost.charAt(topMost.length()-1)!='\\' && args[i].charAt(0)!='\\'){
							topMost += "\\";
						}
						topMost += args[i];  //if the fileName was not absolute
					}
				}else{
					if(i>0){
					topMost +=" ";
					}
				topMost += args[i];
				}
			}
			try{
				System.out.println("");
				System.out.println("Running Jhove for module "+module+"...");
				System.out.println("");
				if(!module.equals("bytestream")){
					runJhove.scanWithJhove(topMost,topMost+"_Jhove_"+module+"Out.xml", jhoveConfig, module+"-hul");
				}else{
					runJhove.scanWithJhove(topMost,topMost+"_Jhove_"+module+"Out.xml", jhoveConfig, module);
				}
			}catch(Exception e){
				e.printStackTrace(new PrintStream(System.out));
			}
			
		}
		
	}

	public static void scanWithJhove(String fileName, String outputFile, String jhoveConfig, String module) throws Exception{
			
			String[] args = new String[9];
			args[0] = "-o";
			args[1] = outputFile;
			
			if(!jhoveConfig.equals("")){
				args[2] = "-c";
				args[3] = jhoveConfig+"\\jhove.conf";
			}else{
				args[2] ="";
				args[3] ="";
			}
			args[4] = "-m";
			args[5] = module;
			args[6] = "-h";
			args[7] = "xml";
			args[8] = fileName;
			
			System.out.println("");
			
			Jhove.main(args);
	}
	
	public static void scanWithAllJhoveModules(String fileName, String configFile) throws Exception{
		scanWithJhove(fileName, fileName+"_Jhove_aiffOut.xml", configFile, "aiff-hul");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_asciiOut.xml",  configFile, "ascii-hul");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_bytestreamOut.xml",  configFile, "bytestream");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_gifOut.xml", configFile, "gif-hul");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_htmlOut.xml", configFile, "html-hul");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_jpegOut.xml", configFile, "jpeg-hul");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_jpeg2000Out.xml", configFile, "jpeg2000-hul");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_pdfOut.xml", configFile, "pdf-hul");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_tiffOut.xml", configFile, "tiff-hul");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_utf8Out.xml", configFile, "utf8-hul");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_waveOut.xml", configFile, "wave-hul");
		System.gc();
		scanWithJhove(fileName, fileName+"_Jhove_xmlOut.xml", configFile,  "xml-hul");
		System.gc();
	}
}